Index: trunk/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/AnonymousUserException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/AnonymousUserException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/AnonymousUserException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/HiveException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/HiveException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/HiveException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/OptimizerNotFoundException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/OptimizerNotFoundException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/OptimizerNotFoundException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/ResourceNotFoundException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/ResourceNotFoundException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/ResourceNotFoundException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/ServiceClientFactoryException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/ServiceClientFactoryException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/ServiceClientFactoryException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 16565)
@@ -11,5 +11,5 @@
     <RootNamespace>HeuristicLab.Clients.Hive</RootNamespace>
     <AssemblyName>HeuristicLab.Clients.Hive-3.3</AssemblyName>
-    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <TargetFrameworkProfile />
@@ -107,8 +107,17 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="Google.Protobuf, Version=3.6.1.0, Culture=neutral, PublicKeyToken=a7d26565bac4d604, processorArchitecture=MSIL">
+      <HintPath>..\..\packages\Google.Protobuf.3.6.1\lib\net45\Google.Protobuf.dll</HintPath>
+    </Reference>
+    <Reference Include="HEAL.Attic, Version=1.0.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <HintPath>..\..\packages\HEAL.Attic.1.0.0-pre01\lib\netstandard2.0\HEAL.Attic.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Configuration" />
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
+    <Reference Include="System.Drawing.Common, Version=4.0.0.1, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
+      <HintPath>..\..\packages\System.Drawing.Common.4.5.1\lib\net461\System.Drawing.Common.dll</HintPath>
+    </Reference>
     <Reference Include="System.Runtime.Remoting" />
     <Reference Include="System.Runtime.Serialization" />
@@ -143,4 +152,5 @@
       <SubType>Designer</SubType>
     </None>
+    <None Include="packages.config" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="Exceptions\AddTaskToHiveException.cs" />
Index: trunk/HeuristicLab.Clients.Hive/3.3/HiveAdminClient.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HiveAdminClient.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HiveAdminClient.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -29,5 +29,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 using HeuristicLab.PluginInfrastructure;
 
@@ -35,5 +35,5 @@
 
   [Item("Hive Task", "Represents a hive task.")]
-  [StorableClass]
+  [StorableType("AB546F71-AB78-44AF-9954-1A269D278C56")]
   public class HiveTask : NamedItem, IItemTree<HiveTask>, IDisposable {
     protected static object locker = new object();
@@ -170,5 +170,5 @@
     #region Constructors and Cloning
     [StorableConstructor]
-    protected HiveTask(bool deserializing) { }
+    protected HiveTask(StorableConstructorFlag _) : base(_) { }
 
     public HiveTask()
@@ -541,5 +541,5 @@
 
   [Item("Hive Task", "Represents a hive task.")]
-  [StorableClass]
+  [StorableType("F185C6FD-7282-4EE1-9F76-C4DD32C69207")]
   public class HiveTask<T> : HiveTask where T : ItemTask {
 
@@ -552,5 +552,5 @@
     public HiveTask() : base() { }
     [StorableConstructor]
-    protected HiveTask(bool deserializing) { }
+    protected HiveTask(StorableConstructorFlag _) : base(_) { }
     public HiveTask(T itemTask) : base(itemTask, true) { }
     protected HiveTask(HiveTask<T> original, Cloner cloner)
Index: trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/OptimizerHiveTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/OptimizerHiveTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/HiveTasks/OptimizerHiveTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/IHiveServiceLocator.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/IHiveServiceLocator.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/IHiveServiceLocator.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/JobResultPoller.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/JobResultPoller.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/JobResultPoller.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Properties/AssemblyInfo.cs.frame	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Properties/AssemblyInfo.cs.frame	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ScopeExtensions.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ScopeExtensions.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ScopeExtensions.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Downtime.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Downtime.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Downtime.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Heartbeat.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Heartbeat.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Heartbeat.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItem.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItem.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItem.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItemCollection.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItemCollection.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItemCollection.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/IHiveItem.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/IHiveItem.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/IHiveItem.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobPermission.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobPermission.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobPermission.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,6 +24,8 @@
 using System.Linq;
 using HeuristicLab.Common;
+using HEAL.Attic;
 
 namespace HeuristicLab.Clients.Hive {
+  [StorableType("35B1D7FC-0A94-48E0-A17D-888C2AFE58D9")]
   public partial class LightweightTask : IDeepCloneable, IContent {
     public StateLog CurrentStateLog { get { return StateLog.LastOrDefault(); } }
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/NamedHiveItem.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/NamedHiveItem.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/NamedHiveItem.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Plugin.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Plugin.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Plugin.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/PluginData.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/PluginData.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/PluginData.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Project.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Project.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Project.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Resource.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Resource.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Resource.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/ResourcePermission.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/ResourcePermission.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/ResourcePermission.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Slave.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Slave.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Slave.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveGroup.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveGroup.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveGroup.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,6 +23,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Common;
+using HEAL.Attic;
 
 namespace HeuristicLab.Clients.Hive {
+  [StorableType("2590428E-5F97-48EC-AE82-E2F614BEF34C")]
   public partial class Task : LightweightTask {
 
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/TaskData.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/TaskData.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/TaskData.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserPriority.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserPriority.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserPriority.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/StateLogList.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/StateLogList.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/StateLogList.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,12 +23,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Clients.Hive {
-  [StorableClass]
+  [StorableType("A7A58A86-6059-4364-AD3B-BA439CB85101")]
   public class StateLogList : ItemList<StateLog> {
 
     [StorableConstructor]
-    protected StateLogList(bool deserializing) : base(deserializing) { }
+    protected StateLogList(StorableConstructorFlag _) : base(_) { }
     public StateLogList() : base() { }
     protected StateLogList(StateLogList original, Cloner cloner) : base(original, cloner) { }
Index: trunk/HeuristicLab.Clients.Hive/3.3/StateLogListList.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/StateLogListList.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/StateLogListList.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,12 +23,12 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Clients.Hive {
-  [StorableClass]
+  [StorableType("DE613E80-EA09-4F5E-AB15-2E830866FCE3")]
   public class StateLogListList : ItemList<StateLogList> {
 
     [StorableConstructor]
-    protected StateLogListList(bool deserializing) : base(deserializing) { }
+    protected StateLogListList(StorableConstructorFlag _) : base(_) { }
     public StateLogListList() : base() { }
     protected StateLogListList(StateLogListList original, Cloner cloner) : base(original, cloner) { }
Index: trunk/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,8 +24,8 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Clients.Hive {
-  [StorableClass]
+  [StorableType("FFDE8A4B-FDEC-47AA-B8E2-B16E5B513055")]
   public class EngineTask : ItemTask {
     public override HiveTask CreateHiveTask() {
@@ -63,5 +63,5 @@
 
     [StorableConstructor]
-    protected EngineTask(bool deserializing) : base(deserializing) { }
+    protected EngineTask(StorableConstructorFlag _) : base(_) { }
     protected EngineTask(EngineTask original, Cloner cloner)
       : base(original, cloner) {
Index: trunk/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,10 +26,10 @@
 using HeuristicLab.Core;
 using HeuristicLab.Hive;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Clients.Hive {
   [Item("Item Task", "Represents a executable hive task which contains a HeuristicLab Item.")]
-  [StorableClass]
+  [StorableType("69EB65A5-9132-41B6-BE1D-60EDA46EF3C5")]
   public abstract class ItemTask : NamedItem, ITask {
     public virtual HiveTask CreateHiveTask() {
@@ -72,5 +72,5 @@
 
     [StorableConstructor]
-    protected ItemTask(bool deserializing) { }
+    protected ItemTask(StorableConstructorFlag _) : base(_) { }
     protected ItemTask(ItemTask original, Cloner cloner)
       : base(original, cloner) {
Index: trunk/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,9 +24,9 @@
 using HeuristicLab.Core;
 using HeuristicLab.Optimization;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Clients.Hive.Jobs {
   [Item("Optimizer Task", "Represents Task which executes a IOptimizer object.")]
-  [StorableClass]
+  [StorableType("9A59FAAF-3F5C-4629-B22D-714488DC2678")]
   public class OptimizerTask : ItemTask {
     public override HiveTask CreateHiveTask() {
@@ -60,5 +60,5 @@
     }
     [StorableConstructor]
-    protected OptimizerTask(bool deserializing) { }
+    protected OptimizerTask(StorableConstructorFlag _) : base(_) { }
     protected OptimizerTask(OptimizerTask original, Cloner cloner)
       : base(original, cloner) {
Index: trunk/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTree.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTree.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTree.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTreeAction.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTreeAction.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTreeAction.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/Util/PersistenceUtil.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Util/PersistenceUtil.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Util/PersistenceUtil.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,5 +23,5 @@
 using System.Collections.Generic;
 using System.IO;
-using HeuristicLab.Persistence.Core;
+using HEAL.Attic;
 using HeuristicLab.Persistence.Default.Xml;
 
@@ -29,23 +29,24 @@
   public static class PersistenceUtil {
     public static byte[] Serialize(object obj, out IEnumerable<Type> types) {
-      using (MemoryStream memStream = new MemoryStream()) {
-        XmlGenerator.Serialize(obj, memStream, ConfigurationService.Instance.GetConfiguration(new XmlFormat()), false, out types);
-        byte[] jobByteArray = memStream.ToArray();
-        return jobByteArray;
-      }
+      var ser = new ProtoBufSerializer();
+      var bytes = ser.Serialize(obj, out SerializationInfo info);
+      types = info.SerializedTypes;
+      return bytes;
     }
 
     public static byte[] Serialize(object obj) {
-      using (MemoryStream memStream = new MemoryStream()) {
-        XmlGenerator.Serialize(obj, memStream);
-        byte[] jobByteArray = memStream.ToArray();
-        return jobByteArray;
-      }
+      var ser = new ProtoBufSerializer();
+      return ser.Serialize(obj);
     }
 
     public static T Deserialize<T>(byte[] sjob) {
-      using (MemoryStream memStream = new MemoryStream(sjob)) {
-        T job = XmlParser.Deserialize<T>(memStream);
-        return job;
+      var ser = new ProtoBufSerializer();
+      try {
+        return (T)ser.Deserialize(sjob);
+      } catch (Exception) {
+        // retry with old persistence
+        using (MemoryStream memStream = new MemoryStream(sjob)) {
+          return XmlParser.Deserialize<T>(memStream);
+        }
       }
     }
Index: trunk/HeuristicLab.Clients.Hive/3.3/Util/PluginUtil.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/Util/PluginUtil.cs	(revision 16527)
+++ trunk/HeuristicLab.Clients.Hive/3.3/Util/PluginUtil.cs	(revision 16565)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/HeuristicLab.Clients.Hive/3.3/packages.config
===================================================================
--- trunk/HeuristicLab.Clients.Hive/3.3/packages.config	(revision 16565)
+++ trunk/HeuristicLab.Clients.Hive/3.3/packages.config	(revision 16565)
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<packages>
+  <package id="Google.Protobuf" version="3.6.1" targetFramework="net461" />
+  <package id="HEAL.Attic" version="1.0.0-pre01" targetFramework="net461" />
+  <package id="System.Drawing.Common" version="4.5.1" targetFramework="net461" />
+</packages>
